unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SCDEControl, SCDrawingCommons, SCDrawingSurface, SCDrawingEditor, SCDrawingShapes,
  ToolWin, ComCtrls, ImgList, Menus, ActnList, ExtDlgs, Jpeg, StdCtrls,
  Buttons, FileCtrl, ExtCtrls, SCStdControls;

type
  TMainForm = class(TForm)
    SCCAD1: TSCDeEditor;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    MenuEdit: TMenuItem;
    MenuInsert: TMenuItem;
    MenuRectangle: TMenuItem;
    ActionList1: TActionList;
    InsertRect: TAction;
    InsertPolygon: TAction;
    InsertBezier: TAction;
    InsertEllipse: TAction;
    InsertCircle: TAction;
    InsertText: TAction;
    MenuCircle: TMenuItem;
    MenuEllipse: TMenuItem;
    MenuPolygon: TMenuItem;
    MenuBezier: TMenuItem;
    MenuText: TMenuItem;
    InsertArc: TAction;
    MenuArc: TMenuItem;
    ToolSelect: TAction;
    MenuSelect: TMenuItem;
    ToolSelectAll: TAction;
    MenuSelectAll: TMenuItem;
    N2: TMenuItem;
    ToolPen: TAction;
    EditDelete: TAction;
    EditNewLayer: TAction;
    InsertPicture: TAction;
    MenuPicture: TMenuItem;
    MenuDelete: TMenuItem;
    InsertFreehand: TAction;
    MenuFreehand: TMenuItem;
    ArrangeSendToBack: TAction;
    ArrangeBringToFront: TAction;
    MenuArrange1: TMenuItem;
    MenuBringToFront: TMenuItem;
    MenuSendToBack: TMenuItem;
    ArrangeBringForward: TAction;
    ArrangeSendBackward: TAction;
    MenuBringForward: TMenuItem;
    MenuSendBackward: TMenuItem;
    ToolDeselect: TAction;
    Select1: TMenuItem;
    MenuDeselect: TMenuItem;
    ToolRemovePoint: TAction;
    MenuPen: TMenuItem;
    N1: TMenuItem;
    MenuRemovePoint: TMenuItem;
    FileSave: TAction;
    FileSaveAs: TAction;
    FileOpen: TAction;
    FileClose: TAction;
    File1: TMenuItem;
    MenuOpen: TMenuItem;
    MenuSave: TMenuItem;
    MenuSaveAs: TMenuItem;
    N4: TMenuItem;
    MenuClose1: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ArrangeGroup: TAction;
    ArrangeUngroup: TAction;
    N5: TMenuItem;
    MenuGroup: TMenuItem;
    MenuUngroup: TMenuItem;
    FileNew: TAction;
    MenuNew: TMenuItem;
    ToolBar1: TToolBar;
    ButtonNew: TToolButton;
    ButtonOpen: TToolButton;
    ButtonSave: TToolButton;
    ToolButton10: TToolButton;
    ButtonBringToFront: TToolButton;
    ButtonBringForward: TToolButton;
    ButtonSendToBack: TToolButton;
    ButtonSendBackward: TToolButton;
    ToolButton32: TToolButton;
    ButtonGroup: TToolButton;
    ButtonUngroup: TToolButton;
    ToolBar3: TToolBar;
    ButtonSelect: TToolButton;
    ToolButton2: TToolButton;
    ButtonRect: TToolButton;
    ButtonEllipse: TToolButton;
    ButtonCircle: TToolButton;
    ButtonArc: TToolButton;
    ButtonPolygon: TToolButton;
    ButtonBezier: TToolButton;
    ButtonFreeHand: TToolButton;
    ButtonText: TToolButton;
    ButtonLabel: TToolButton;
    InsertLabel: TAction;
    ButtonPicture: TToolButton;
    ToolButton1: TToolButton;
    ButtonDelete: TToolButton;
    ButtonRemovePoint: TToolButton;
    ButtonPen: TToolButton;
    ToolButton3: TToolButton;
    ButtonCut: TToolButton;
    ToolButton5: TToolButton;
    ButtonCopy: TToolButton;
    ButtonPaste: TToolButton;
    EditCut: TAction;
    EditCopy: TAction;
    EditPaste: TAction;
    ButtonUndo: TToolButton;
    ButtonRedo: TToolButton;
    ToolButton7: TToolButton;
    EditUndo: TAction;
    EditRedo: TAction;
    MenuUndo: TMenuItem;
    MenuRedo: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    MenuCut: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    ToolPan: TAction;
    ButtonPan: TToolButton;
    ToolButton6: TToolButton;
    ButtonZoom: TToolButton;
    ViewZoomIn: TAction;
    ViewZoomOut: TAction;
    ViewZoom10: TAction;
    ViewZoom25: TAction;
    ViewZoom50: TAction;
    ViewZoom100: TAction;
    ViewZoom200: TAction;
    ViewZoom400: TAction;
    ViewZoom800: TAction;
    ViewZoom1600: TAction;
    ViewZoom3200: TAction;
    ViewZoom6400: TAction;
    ViewZoom10000: TAction;
    View1: TMenuItem;
    ZoomIn1: TMenuItem;
    ZoomOut1: TMenuItem;
    Zoom1: TMenuItem;
    Zoom101: TMenuItem;
    Zoom251: TMenuItem;
    Zoom501: TMenuItem;
    Zoom1001: TMenuItem;
    Zoom2001: TMenuItem;
    Zoom4001: TMenuItem;
    Zoom8001: TMenuItem;
    Zoom16001: TMenuItem;
    Zoom32001: TMenuItem;
    Zoom64001: TMenuItem;
    Zoom100001: TMenuItem;
    N3: TMenuItem;
    PopupMenu1: TPopupMenu;
    Zoom102: TMenuItem;
    Zoom252: TMenuItem;
    Zoom502: TMenuItem;
    Zoom1002: TMenuItem;
    Zoom2002: TMenuItem;
    Zoom4002: TMenuItem;
    Zoom8002: TMenuItem;
    Zoom16002: TMenuItem;
    Zoom32002: TMenuItem;
    Zoom64002: TMenuItem;
    Zoom100002: TMenuItem;
    ButtonZoomOut: TToolButton;
    ViewProperties: TAction;
    Properties1: TMenuItem;
    N8: TMenuItem;
    procedure InsertPolygonExecute(Sender: TObject);
    procedure InsertBezierExecute(Sender: TObject);
    procedure InsertEllipseExecute(Sender: TObject);
    procedure InsertCircleExecute(Sender: TObject);
    procedure InsertTextExecute(Sender: TObject);
    procedure InsertArcExecute(Sender: TObject);
    procedure InsertRectExecute(Sender: TObject);
    procedure ToolSelectExecute(Sender: TObject);
    procedure ToolSelectAllExecute(Sender: TObject);
    procedure ToolPenExecute(Sender: TObject);
    procedure InsertPictureExecute(Sender: TObject);
    procedure EditDeleteExecute(Sender: TObject);
    procedure SCCAD1EditStateChange(Sender: TObject);
    procedure SCCAD1SelectionChange(Sender: TObject);
    procedure EditNewLayerExecute(Sender: TObject);
    procedure InsertFreehandExecute(Sender: TObject);
    procedure ArrangeBringToFrontExecute(Sender: TObject);
    procedure ArrangeSendToBackExecute(Sender: TObject);
    procedure ArrangeBringForwardExecute(Sender: TObject);
    procedure ArrangeSendBackwardExecute(Sender: TObject);
    procedure ToolDeselectExecute(Sender: TObject);
    procedure ToolRemovePointExecute(Sender: TObject);
    procedure FileCloseExecute(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure FileSaveAsExecute(Sender: TObject);
    procedure FileOpenExecute(Sender: TObject);
    procedure ArrangeGroupExecute(Sender: TObject);
    procedure ArrangeUngroupExecute(Sender: TObject);
    procedure FileNewExecute(Sender: TObject);
    procedure SCCAD1EndNewShape(Sender: TObject; Shape: TSCDeShapeBase);
    procedure InsertLabelExecute(Sender: TObject);
    procedure EditCutExecute(Sender: TObject);
    procedure EditCopyExecute(Sender: TObject);
    procedure EditPasteExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SCCAD1ClipboardChange(Sender: TObject);
    procedure EditUndoExecute(Sender: TObject);
    procedure EditRedoExecute(Sender: TObject);
    procedure SCCAD1Change(Sender: TObject);
    procedure ToolPanExecute(Sender: TObject);
    procedure ViewZoom10Execute(Sender: TObject);
    procedure ViewZoom25Execute(Sender: TObject);
    procedure ViewZoom50Execute(Sender: TObject);
    procedure ViewZoom100Execute(Sender: TObject);
    procedure ViewZoom200Execute(Sender: TObject);
    procedure ViewZoom400Execute(Sender: TObject);
    procedure ViewZoom800Execute(Sender: TObject);
    procedure ViewZoom1600Execute(Sender: TObject);
    procedure ViewZoom3200Execute(Sender: TObject);
    procedure ViewZoom6400Execute(Sender: TObject);
    procedure ViewZoom10000Execute(Sender: TObject);
    procedure ViewZoomInExecute(Sender: TObject);
    procedure ViewZoomOutExecute(Sender: TObject);
    procedure ViewPropertiesExecute(Sender: TObject);
    procedure SCCAD1InsertLayer(Sender: TObject; Shape: TSCDeShapeBase);
    procedure SCCAD1InsertShape(Sender: TObject; Shape: TSCDeShapeBase);
    procedure SCCAD1RemoveLayer(Sender: TObject; Shape: TSCDeShapeBase);
    procedure SCCAD1RemoveShape(Sender: TObject; Shape: TSCDeShapeBase);
  private
    FFileName: String;
    procedure UpdateProperties;
    procedure UpdateLayers;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses PropUnit;

const
  ZoomArray: array[0..10] of Integer = (10, 25, 50, 100, 200, 400, 800,
    1600, 3200, 6400, 10000);

{$R *.DFM}

procedure TMainForm.InsertPolygonExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDePolygon);
end;

procedure TMainForm.InsertBezierExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDePolyBezier);
end;

procedure TMainForm.InsertEllipseExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDeEllipse);
end;

procedure TMainForm.InsertCircleExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDeCircle);
end;

procedure TMainForm.InsertTextExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDeText);
end;

procedure TMainForm.InsertArcExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDeArc);
end;

procedure TMainForm.InsertRectExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDeRectangle);
end;

procedure TMainForm.ToolSelectExecute(Sender: TObject);
begin
  SCCAD1.SetSelecting;
end;

procedure TMainForm.ToolSelectAllExecute(Sender: TObject);
begin
  SCCAD1.SelectAll;
end;

procedure TMainForm.ToolPenExecute(Sender: TObject);
begin
  SCCAD1.BeginPointAdd;
end;

procedure TMainForm.InsertPictureExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDePicture);
end;

procedure TMainForm.EditDeleteExecute(Sender: TObject);
begin
  SCCAD1.DeleteSelection;
end;

procedure TMainForm.SCCAD1EditStateChange(Sender: TObject);
var
  InSelect, InCreation: Boolean;
begin
  InSelect := SCCAD1.EditState in [scesNone, scesRectSelect,
    scesMoving, scesSizing, scesRotating, scesNewGuide, scesToolEdit];

  InCreation := SCCAD1.EditState = scesCreateNew;

  ToolSelect.Checked := InSelect;
  ToolPen.Checked := SCCAD1.EditState = scesAddPoint;
  ToolRemovePoint.Checked := SCCAD1.EditState = scesRemovePoint;
  ToolPan.Checked := SCCAD1.EditState = scesZoomRect;

  InsertRect.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDeRectangle);
  InsertPolygon.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDePolygon);
  InsertBezier.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDePolyBezier);
  InsertCircle.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDeCircle);
  InsertEllipse.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDeEllipse);
  InsertText.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDeText);
  InsertArc.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDeArc);
  InsertFreehand.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDeFreeline);
  InsertPicture.Checked := InCreation and (SCCAD1.NewShapeClass = TSCDePicture);
end;

procedure TMainForm.SCCAD1SelectionChange(Sender: TObject);
begin
  ToolDeselect.Enabled := SCCAD1.SelectionCount > 0;
  ToolPen.Enabled := SCCAD1.SelectionCount > 0;
  ToolRemovePoint.Enabled := SCCAD1.SelectionCount > 0;

  EditCut.Enabled := SCCAD1.SelectionCount > 0;
  EditCopy.Enabled := SCCAD1.SelectionCount > 0;
  EditDelete.Enabled := SCCAD1.SelectionCount > 0;

  ArrangeBringToFront.Enabled := SCCAD1.SelectionCount > 0;
  ArrangeSendToBack.Enabled := SCCAD1.SelectionCount > 0;
  ArrangeBringForward.Enabled := SCCAD1.SelectionCount > 0;
  ArrangeSendBackward.Enabled := SCCAD1.SelectionCount > 0;
  ArrangeGroup.Enabled := SCCAD1.SelectionCount > 0;
  ArrangeUngroup.Enabled := SCCAD1.SelectionCount > 0;

  UpdateProperties;
end;

procedure TMainForm.EditNewLayerExecute(Sender: TObject);
begin
  SCCAD1.ActiveLayer := TSCDeLayer.Create(SCCAD1);
end;

procedure TMainForm.InsertFreehandExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDeFreeLine);
end;

procedure TMainForm.ArrangeBringToFrontExecute(Sender: TObject);
begin
  SCCAD1.BringToFront;
end;

procedure TMainForm.ArrangeSendToBackExecute(Sender: TObject);
begin
  SCCAD1.SendToBack;
end;

procedure TMainForm.ArrangeBringForwardExecute(Sender: TObject);
begin
  SCCAD1.BringForward;
end;

procedure TMainForm.ArrangeSendBackwardExecute(Sender: TObject);
begin
  SCCAD1.SendBackward;
end;

procedure TMainForm.ToolDeselectExecute(Sender: TObject);
begin
  SCCAD1.ClearSelection;
end;

procedure TMainForm.ToolRemovePointExecute(Sender: TObject);
begin
  SCCAD1.BeginPointRemove;
end;

procedure TMainForm.FileCloseExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FileSaveExecute(Sender: TObject);
begin
  if (FFileName <> '') and DirectoryExists(ExtractFilePath(FFileName)) then
    SCCAD1.SaveToFile(FFileName)
  else
    FileSaveAsExecute(FileSaveAs);
end;

procedure TMainForm.FileSaveAsExecute(Sender: TObject);
var
  FileName: String;
begin
  SaveDialog1.FileName := FFileName;

  if SaveDialog1.Execute then
  begin
    FileName := SaveDialog1.FileName;
    if ExtractFileExt(FileName) = '' then FileName := FileName + '.sde';

    SCCAD1.SaveToFile(FileName);

    FFileName := FileName;
    Caption := 'Mini CAD - [' + FFileName + ']';
  end;
end;

procedure TMainForm.FileOpenExecute(Sender: TObject);
var
  FileName: String;
begin
  if OpenDialog1.Execute then
  begin
    FileName := OpenDialog1.FileName;

    SCCAD1.LoadFromFile(FileName);
    FFileName := FileName;

    Caption := 'Mini CAD - [' + FFileName + ']';
  end;
end;

procedure TMainForm.ArrangeGroupExecute(Sender: TObject);
begin
  SCCAD1.GroupSelection;
end;

procedure TMainForm.ArrangeUngroupExecute(Sender: TObject);
begin
  SCCAD1.UngroupSelection;
end;

procedure TMainForm.FileNewExecute(Sender: TObject);
begin
  SCCAD1.Clear;
  FFileName := '';
  Caption := 'Mini CAD - [New]';
end;

procedure TMainForm.SCCAD1EndNewShape(Sender: TObject;
  Shape: TSCDeShapeBase);
var
  S: String;
begin
  if Shape <> nil then
  begin
    if Shape is TSCDePicture then
    begin
      if not OpenPictureDialog1.Execute then
        Shape.Free
      else
        TSCDePicture(Shape).Picture.LoadFromFile(OpenPictureDialog1.FileName);
    end else
    if Shape is TSCDeText then
    begin
      S := '';
      if not InputQuery('Text', 'Enter text value', S) then
        S := '';

      S := Trim(S);
      if S = '' then
      begin
        Shape.Free;
        Exit;
      end;

      TSCDeText(Shape).Caption := S;
    end else
    if Shape is TSCDeLabel then
    begin
      S := '';
      if not InputQuery('Label', 'Enter label value', S) then
        S := '';

      S := Trim(S);
      if S = '' then
      begin
        Shape.Free;
        Exit;
      end;

      TSCDeLabel(Shape).Caption := S;
    end;
  end;
end;

procedure TMainForm.InsertLabelExecute(Sender: TObject);
begin
  SCCAD1.SetNewShapeClass(TSCDeLabel);
end;

procedure TMainForm.EditCutExecute(Sender: TObject);
begin
  SCCAD1.CutToClipboard;
end;

procedure TMainForm.EditCopyExecute(Sender: TObject);
begin
  SCCAD1.CopyToClipboard;
end;

procedure TMainForm.EditPasteExecute(Sender: TObject);
begin
  SCCAD1.PasteFromClipboard;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  SCCAD1.ActiveLayer := TSCDeLayer.Create(SCCAD1);
  // ButtonZoom.ImageIndex := 40;
end;

procedure TMainForm.SCCAD1ClipboardChange(Sender: TObject);
begin
  EditPaste.Enabled := SCCAD1.HasClipboardData;
end;

procedure TMainForm.EditUndoExecute(Sender: TObject);
begin
  SCCAD1.Undo;
  UpdateProperties;
end;

procedure TMainForm.EditRedoExecute(Sender: TObject);
begin
  SCCAD1.Redo;
  UpdateProperties;
end;

procedure TMainForm.SCCAD1Change(Sender: TObject);
begin
  EditUndo.Enabled := SCCAD1.CanUndo;
  EditRedo.Enabled := SCCAD1.CanRedo;
end;

procedure TMainForm.ToolPanExecute(Sender: TObject);
begin
  SCCAD1.SetPanView;
end;

procedure TMainForm.ViewZoom10Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 10;
end;

procedure TMainForm.ViewZoom25Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 25;
end;

procedure TMainForm.ViewZoom50Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 50;
end;

procedure TMainForm.ViewZoom100Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 100;
end;

procedure TMainForm.ViewZoom200Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 200;
end;

procedure TMainForm.ViewZoom400Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 400;
end;

procedure TMainForm.ViewZoom800Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 800;
end;

procedure TMainForm.ViewZoom1600Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 1600;
end;

procedure TMainForm.ViewZoom3200Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 3200;
end;

procedure TMainForm.ViewZoom6400Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 6400;
end;

procedure TMainForm.ViewZoom10000Execute(Sender: TObject);
begin
  SCCAD1.Zoom := 10000;
end;

procedure TMainForm.ViewZoomInExecute(Sender: TObject);
var
  Z, I, Min: Integer;
begin
  Z := SCCAD1.Zoom;
  
  if Z < 10 then Z := 10
  else if Z > 10000 then Z := 10000;

  Min := 0;
  for I := 0 to 10 do
  begin
    if (Z >= Min) and (Z < ZoomArray[I]) then
    begin
      Z := ZoomArray[I];
      Break;
    end;

    Min := ZoomArray[I];
  end;

  SCCAD1.Zoom := Z;
end;

procedure TMainForm.ViewZoomOutExecute(Sender: TObject);
var
  Z, I, Max: Integer;
begin
  Z := SCCAD1.Zoom;
  
  if Z < 10 then Z := 10
  else if Z > 10000 then Z := 10000;

  Max := 10000;
  for I := 10 downto 0 do
  begin
    if (Z <= Max) and (Z > ZoomArray[I]) then
    begin
      Z := ZoomArray[I];
      Break;
    end;

    Max := ZoomArray[I];
  end;

  SCCAD1.Zoom := Z;
end;

procedure TMainForm.ViewPropertiesExecute(Sender: TObject);
begin
  if PropForm = nil then
  begin
    Application.CreateForm(TPropForm, PropForm);
    PropForm.SetCAD(SCCAD1);

    UpdateProperties;
    UpdateLayers;
  end;

  PropForm.Show;
  PropForm.BringToFront;
end;

procedure TMainForm.UpdateProperties;
begin
  if PropForm <> nil then PropForm.UpdateProps;
end;

procedure TMainForm.SCCAD1InsertLayer(Sender: TObject;
  Shape: TSCDeShapeBase);
begin
  UpdateLayers;
end;

procedure TMainForm.UpdateLayers;
begin
  if PropForm <> nil then PropForm.UpdateLayers;
end;

procedure TMainForm.SCCAD1InsertShape(Sender: TObject;
  Shape: TSCDeShapeBase);
begin
  UpdateLayers;
end;

procedure TMainForm.SCCAD1RemoveLayer(Sender: TObject;
  Shape: TSCDeShapeBase);
begin
  UpdateLayers;
end;

procedure TMainForm.SCCAD1RemoveShape(Sender: TObject;
  Shape: TSCDeShapeBase);
begin
  UpdateLayers;
end;

end.
